//vC[pl̕`揈NX
#ifndef _C_VIEW_PLAYER_
#define _C_VIEW_PLAYER_

#include "..\Skin\CSkinPlayer.h"
#include "..\ComCtrl\CToolTip.H"
#include "..\GDI\CSprite.h"
#include "..\Setting\CSetting.h"

#include "WndDef.h"

//I[fBI{[ύX̃R[obN֐
typedef LONG (WINAPI *LPPROC_AudioVolume)(LPVOID , long);

//}EXCxg̃Rg[ID
enum _VPCTRLID{
	VP_CTRL_NONE    = 0,
	VP_CTRL_VOLUME,
	VP_CTRL_BUTTON,
};

#define PLAYER_INFO_LENGTH 256
#define PLAYER_INFO_SCROLL_WAIT 20

//{^Ԑݒp\
typedef struct _ST_CV_PLY_FUNC_PARAM{
	long lVolume;
	BOOL bIsMute;		//~[g̏

	int nAppStat;		//Av̏
	int nPlayerStat;	//vC[̏
	BOOL bIsCapPre;		//vr[̗L
	BOOL bIsCapRec;		//^̗L

	int nTime;
}ST_CV_PLY_FUNC_PARAM;

//////////////////////////////////////////////////////////////////////////////
class CViewPlayer {

public:

	CViewPlayer();
	~CViewPlayer();

	//XLf[^̓ǂݍ
	BOOL ReadSkinData(char *pszFile);
	void ReleaseSprite(void);//ǂݍ񂾃rbg}bv

	void put_cSetting(CSetting *pSetting);

	//c[`bv̐po
	void SetToolTipsActivate(BOOL flag);//c[`bvON/OFFݒ肷
	BOOL GetToolTipsActivate(void);
	void InitToolTip(void);				//c[`bv̕
	void SetTooltipRect(void);//c[`bv̈ʒuݒ肷

	void SetSkinFolder(char *pszPath){
		m_szSkinFolder[MAX_PATH-1] = '\0';
		strncpy(m_szSkinFolder,pszPath,MAX_PATH-1);
	}

	void SetVolumeCallBack(LPPROC_AudioVolume pProc,LPVOID lParam){
		m_pProcVolume = pProc;
		m_pAudioProcParam = lParam;
	}

	//ݒ֐
	void SetPlayerInfo(char *pszInfo);		//t@C/ǂƂĕ\镶ݒ肷
	BOOL IsSamePlayerInfo(char *pszInfo);	//\eꂩmF

	//O̕`֐
	void DrawVolume(long lVolume);		//{[`悷
	void DrawButton(void);		//{^`悷
	void DrawPlayerStat(int nAppStat);	//vC[̏Ԃ`悷
	void DrawPlayerInfo(void);
	void DrawClock(int nTime);
	void DrawAll(HDC hdc ,RECT rcBackDraw,ST_CV_PLY_FUNC_PARAM *pParam);

	//{^̍XV
	void CheckButtonStat(ST_CV_PLY_FUNC_PARAM *pParam);

	//XL
	int GetSkinWidth(void){return m_cSkin.GetWidth();}
	int GetSkinHeight(void){return m_cSkin.GetHeight();}

	//{^̏
	BOOL IsButton(int x,int y,int *pStyle);//w肵WɃ{^AV[No[Ȃǂ̃Rg[邩mF

	//EChE`ݒ֐
	BOOL SetWindowForm(void);

	//`̃EChE̐ݒ
	void SetWindow(HWND hWnd){m_hWnd = hWnd;}
	void SetInstance(HINSTANCE hInst){m_hInst = hInst;}
	void SetDrawRect(RECT *pRc){CopyMemory(&m_DrawRect,pRc,sizeof(RECT));}

	//nh
	void OnWmMouseMove(HDC hdc, int xPos,int yPos, long *plVol);
	void OnWMLButtonDown(HDC hdc, int xPos,int yPos);
	DWORD OnWMLButtonUp(HDC hdc, int xPos,int yPos, int *pnBtnID, long *plVol);

	void OnWmTimer_InfoScroll(void);

protected:

	HWND m_hWnd;
	HINSTANCE m_hInst;
	RECT m_DrawRect;		//`͈͂̕ێp

	CSetting *m_pcSetting;

	CSkinPlayer m_cSkin;
	char m_szSkinFolder[MAX_PATH];	//XLۑpX

	HRGN m_hRgn;			//[Wnh

	HBITMAP m_hBmpBackBuf;	//`pobNobt@
	HDC m_hDCBackBuf;		//obNobt@pfoCXReLXg
	HGDIOBJ m_hOldBackObj;	//obNobt@`p̌IuWFNg
	

	LPPROC_AudioVolume m_pProcVolume;			//ʒ̃R[obN֐ւ̃|C^
	LPVOID m_pAudioProcParam;					//R[obNɈnp[^

	//{^\p
	PTDIGI_BUTTON *m_pBtnSprite;	//{^̃XvCg
	int m_nBtnSpriteNum;		//XvCg̐

	//{[o[\p
	PTDIGI_BAR m_VolumeSprite; //{[\pXvCg
	BOOL flagVolumeMove;

	//vC[̏\()p
	PTDIGI_PLAYER_STAT m_PlayerStatSprite; //vC[\XvCg
	int m_iPlayerStatus;

	//vC[\(t@CA)p
	char m_szInfomation[PLAYER_INFO_LENGTH];//\镶
	HFONT m_hFontInfomation;//\ɎgptHg
	int m_nDrawPos;
	int m_nDrawMaxWidth;
	int m_nDrawMaxHeight;
	int m_nDrawInfoWidth;
	int m_nDrawPosWait;
	int m_nDrawInfo_LineCount;
	int m_nDrawInfo_RetPos;


	HBITMAP m_hBmpInfoBuf;
	HDC m_hDCInfoBuf;
	HGDIOBJ m_hOldInfoObj;

	//vC[(v)p
	PTDIGI_PLAYER_CLOCK m_ClockSprite;

	//wi̊Gp
	PTDIGI_PLAYER_BACK m_BackGroundSprite;

	//c[`bvpo
	CToolTip *m_pToolTip;//c[`bvEChE
	BOOL m_flagToolTipActivate;//c[`bvON/OFFtO

	//`pobt@
	BOOL CreateBackBuffer(void);	//obt@쐬

	//`ʒuvZp̊֐
	int Calculate_DrawX(RECT *pRc);

	//`p̊֐
	BOOL Draw_Text(HDC hdc,HFONT hFont,char *pszText,PTDIGI_SKIN_FONT *pFont,RECT *pRect);

	//{^̕`
	int DrawButton(HDC hdc ,int x, int y, int iNum ,int iStyle, BOOL fForce);//w肵{^`悷
	void DrawButton(HDC hdc,int x, int y);
	
	//ʏ̕`
	int DrawVolume(HDC hdc,int x,int y, long lVolume);//ʒo[`悷
	void GetVolumeRect(RECT *rc);//{[o[̗̈擾
	int GetVolumePosFromeVolumeBar(POINT point);

	//vC[̏`悷
	int DrawPlayerStat(HDC hdc,int x,int y,int nAppStat);//`悷
	int DrawPlayerInfo(HDC hdc,int x,int y);
	int DrawClock(HDC hdc,int x,int y, int nTime);

	//vC[wi̕`
	int DrawBackGround(HDC hdc,int x,int y, RECT *pRc);//wi`悷

	//EChE`ݒ֐
	BOOL SetWindowForm(HWND hW,CSprite *pSprite,COLORREF colTransparent);

};

#endif
